Index: /palm/trunk/SOURCE/netcdf_data_input_mod.f90
===================================================================
--- /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3050)
+++ /palm/trunk/SOURCE/netcdf_data_input_mod.f90	(revision 3051)
@@ -1829,161 +1775,151 @@
        CALL cpu_log( log_point_s(83), 'NetCDF/ASCII input topo', 'start' )
 
-       DO  ii = 0, io_blocks-1
-          IF ( ii == io_group )  THEN
-!
-!--          Input via palm-input data standard
-             IF ( input_pids_static )  THEN
+!
+!--    Input via palm-input data standard
+       IF ( input_pids_static )  THEN
 #if defined ( __netcdf )
 !
-!--             Open file in read-only mode
-                CALL open_read_file( TRIM( input_file_static ) //              &
-                                     TRIM( coupling_char ), id_topo )
-
-!
-!--             At first, inquire all variable names.
-!--             This will be used to check whether an  input variable exist
-!--             or not.
-                CALL inquire_num_variables( id_topo, num_vars )
-!
-!--             Allocate memory to store variable names and inquire them.
-                ALLOCATE( var_names(1:num_vars) )
-                CALL inquire_variable_names( id_topo, var_names )
-!
-!--             Read x, y - dimensions. Only required for consistency checks.
-                CALL get_dimension_length( id_topo, dim_static%nx, 'x' )
-                CALL get_dimension_length( id_topo, dim_static%ny, 'y' )
-                ALLOCATE( dim_static%x(0:dim_static%nx-1) )
-                ALLOCATE( dim_static%y(0:dim_static%ny-1) )
-                CALL get_variable( id_topo, 'x', dim_static%x )
-                CALL get_variable( id_topo, 'y', dim_static%y )
-!
-!--             Terrain height. First, get variable-related _FillValue attribute
-                IF ( check_existence( var_names, 'zt' ) )  THEN
-                   terrain_height_f%from_file = .TRUE.
-                   CALL get_attribute( id_topo, char_fill,                     &
-                                       terrain_height_f%fill,                  &
-                                       .FALSE., 'zt' )
-!
-!--                PE-wise reading of 2D terrain height.
-                   ALLOCATE ( terrain_height_f%var(nys:nyn,nxl:nxr)  )
-                   DO  i = nxl, nxr
-                      CALL get_variable( id_topo, 'zt',                        &
-                                         i, terrain_height_f%var(:,i) )
-                   ENDDO
-                ELSE
-                   terrain_height_f%from_file = .FALSE.
-                ENDIF
-
-!
-!--             Read building height. First, read its _FillValue attribute,
-!--             as well as lod attribute
-                buildings_f%from_file = .FALSE.
-                IF ( check_existence( var_names, 'buildings_2d' ) )  THEN
-                   buildings_f%from_file = .TRUE.
-                   CALL get_attribute( id_topo, char_lod, buildings_f%lod,     &
-                                       .FALSE., 'buildings_2d' )
-
-                   CALL get_attribute( id_topo, char_fill,                     &
-                                       buildings_f%fill1,                      &
-                                       .FALSE., 'buildings_2d' )
-
-!
-!--                Read 2D topography
-                   IF ( buildings_f%lod == 1 )  THEN
-                      ALLOCATE ( buildings_f%var_2d(nys:nyn,nxl:nxr) )
-                      DO  i = nxl, nxr
-                         CALL get_variable( id_topo, 'buildings_2d',           &
-                                            i, buildings_f%var_2d(:,i) )
-                      ENDDO
-                   ELSE
-                      message_string = 'NetCDF attribute lod ' //              &
-                                       '(level of detail) is not set ' //      &
-                                       'properly for buildings_2d.'
-                      CALL message( 'netcdf_data_input_mod', 'PA0457',         &
-                                     1, 2, 0, 6, 0 )
-                   ENDIF
-                ENDIF
-!
-!--             If available, also read 3D building information. If both are
-!--             available, use 3D information.
-                IF ( check_existence( var_names, 'buildings_3d' ) )  THEN
-                   buildings_f%from_file = .TRUE.
-                   CALL get_attribute( id_topo, char_lod, buildings_f%lod,     &
-                                       .FALSE., 'buildings_3d' )
-
-                   CALL get_attribute( id_topo, char_fill,                     &
-                                       buildings_f%fill2,                      &
-                                       .FALSE., 'buildings_3d' )
-
-                   CALL get_dimension_length( id_topo, buildings_f%nz, 'z' )
-
-                   IF ( buildings_f%lod == 2 )  THEN
-                      ALLOCATE( buildings_f%z(nzb:buildings_f%nz-1) )
-                      CALL get_variable( id_topo, 'z', buildings_f%z )
-
-                      ALLOCATE( buildings_f%var_3d(nzb:buildings_f%nz-1,       &
-                                                   nys:nyn,nxl:nxr) )
-                      buildings_f%var_3d = 0
-!
-!--                   Read data PE-wise. Read yz-slices.
-                      DO  i = nxl, nxr
-                         DO  j = nys, nyn
-                            CALL get_variable( id_topo, 'buildings_3d',        &
-                                               i, j,                           &
-                                               buildings_f%var_3d(:,j,i) )
-                         ENDDO
-                      ENDDO
-                   ELSE
-                      message_string = 'NetCDF attribute lod ' //              &
-                                       '(level of detail) is not set ' //      &
-                                       'properly for buildings_3d.'
-                      CALL message( 'netcdf_data_input_mod', 'PA0457',         &
-                                     1, 2, 0, 6, 0 )
-                   ENDIF
-                ENDIF
-!
-!--             Read building IDs and its FillValue attribute. Further required
-!--             for mapping buildings on top of orography.
-                IF ( check_existence( var_names, 'building_id' ) )  THEN
-                   building_id_f%from_file = .TRUE.
-                   CALL get_attribute( id_topo, char_fill,                     &
-                                       building_id_f%fill, .FALSE.,            &
-                                       'building_id' )
-
-
-                   ALLOCATE ( building_id_f%var(nys:nyn,nxl:nxr) )
-                   DO  i = nxl, nxr
-                      CALL get_variable( id_topo, 'building_id',               &
-                                          i, building_id_f%var(:,i) )
-                   ENDDO
-                ELSE
-                   building_id_f%from_file = .FALSE.
-                ENDIF
-!
-!--             Read building_type and required attributes.
-                IF ( check_existence( var_names, 'building_type' ) )  THEN
-                   building_type_f%from_file = .TRUE.
-                   CALL get_attribute( id_topo, char_fill,                     &
-                                       building_type_f%fill, .FALSE.,          &
-                                       'building_type' )
-
-                   ALLOCATE ( building_type_f%var(nys:nyn,nxl:nxr) )
-                   DO  i = nxl, nxr
-                      CALL get_variable( id_topo, 'building_type',             &
-                                         i, building_type_f%var(:,i) )
-                   ENDDO
-                ELSE
-                   building_type_f%from_file = .FALSE.
-                ENDIF
-
-!
-!--             Close topography input file
-                CALL close_input_file( id_topo )
+!--       Open file in read-only mode
+          CALL open_read_file( TRIM( input_file_static ) //                    &
+                               TRIM( coupling_char ), id_topo )
+!
+!--       At first, inquire all variable names.
+!--       This will be used to check whether an  input variable exist
+!--       or not.
+          CALL inquire_num_variables( id_topo, num_vars )
+!
+!--       Allocate memory to store variable names and inquire them.
+          ALLOCATE( var_names(1:num_vars) )
+          CALL inquire_variable_names( id_topo, var_names )
+!
+!--       Read x, y - dimensions. Only required for consistency checks.
+          CALL get_dimension_length( id_topo, dim_static%nx, 'x' )
+          CALL get_dimension_length( id_topo, dim_static%ny, 'y' )
+          ALLOCATE( dim_static%x(0:dim_static%nx-1) )
+          ALLOCATE( dim_static%y(0:dim_static%ny-1) )
+          CALL get_variable( id_topo, 'x', dim_static%x )
+          CALL get_variable( id_topo, 'y', dim_static%y )
+!
+!--       Terrain height. First, get variable-related _FillValue attribute
+          IF ( check_existence( var_names, 'zt' ) )  THEN
+             terrain_height_f%from_file = .TRUE.
+             CALL get_attribute( id_topo, char_fill, terrain_height_f%fill,    &
+                                 .FALSE., 'zt' )
+!
+!--          Input 2D terrain height.
+             ALLOCATE ( terrain_height_f%var(nys:nyn,nxl:nxr)  )
+             
+             CALL get_variable( id_topo, 'zt', terrain_height_f%var,           &
+                                nxl, nxr, nys, nyn )
+
+          ELSE
+             terrain_height_f%from_file = .FALSE.
+          ENDIF
+
+!
+!--       Read building height. First, read its _FillValue attribute,
+!--       as well as lod attribute
+          buildings_f%from_file = .FALSE.
+          IF ( check_existence( var_names, 'buildings_2d' ) )  THEN
+             buildings_f%from_file = .TRUE.
+             CALL get_attribute( id_topo, char_lod, buildings_f%lod,           &
+                                 .FALSE., 'buildings_2d' )
+
+             CALL get_attribute( id_topo, char_fill, buildings_f%fill1,        &
+                                 .FALSE., 'buildings_2d' )
+
+!
+!--          Read 2D buildings
+             IF ( buildings_f%lod == 1 )  THEN
+                ALLOCATE ( buildings_f%var_2d(nys:nyn,nxl:nxr) )
+
+                CALL get_variable( id_topo, 'buildings_2d',                    &
+                                   buildings_f%var_2d,                         &
+                                   nxl, nxr, nys, nyn )
+             ELSE
+                message_string = 'NetCDF attribute lod ' //                    &
+                                 '(level of detail) is not set ' //            &
+                                 'properly for buildings_2d.'
+                CALL message( 'netcdf_data_input_mod', 'NDI000',               &
+                               1, 2, 0, 6, 0 )
+             ENDIF
+          ENDIF
+!
+!--       If available, also read 3D building information. If both are
+!--       available, use 3D information.
+          IF ( check_existence( var_names, 'buildings_3d' ) )  THEN
+             buildings_f%from_file = .TRUE.
+             CALL get_attribute( id_topo, char_lod, buildings_f%lod,           &
+                                 .FALSE., 'buildings_3d' )      
+
+             CALL get_attribute( id_topo, char_fill, buildings_f%fill2,        &
+                                 .FALSE., 'buildings_3d' )
+
+             CALL get_dimension_length( id_topo, buildings_f%nz, 'z' )
+!
+!--          Read 3D buildings
+             IF ( buildings_f%lod == 2 )  THEN
+                ALLOCATE( buildings_f%z(nzb:buildings_f%nz-1) )
+                CALL get_variable( id_topo, 'z', buildings_f%z )
+
+                ALLOCATE( buildings_f%var_3d(nzb:buildings_f%nz-1,             &
+                                             nys:nyn,nxl:nxr) )
+                buildings_f%var_3d = 0
+                
+                CALL get_variable( id_topo, 'buildings_3d',                    &
+                                   buildings_f%var_3d,                         &
+                                   nxl, nxr, nys, nyn, 0, buildings_f%nz-1 )
+             ELSE
+                message_string = 'NetCDF attribute lod ' //                    &
+                                 '(level of detail) is not set ' //            &
+                                 'properly for buildings_3d.'
+                CALL message( 'netcdf_data_input_mod', 'NDI001',               &
+                               1, 2, 0, 6, 0 )
+             ENDIF
+          ENDIF
+!
+!--       Read building IDs and its FillValue attribute. Further required
+!--       for mapping buildings on top of orography.
+          IF ( check_existence( var_names, 'building_id' ) )  THEN
+             building_id_f%from_file = .TRUE.
+             CALL get_attribute( id_topo, char_fill,                           &
+                                 building_id_f%fill, .FALSE.,                  &
+                                 'building_id' )
+
+             ALLOCATE ( building_id_f%var(nys:nyn,nxl:nxr) )
+             
+             CALL get_variable( id_topo, 'building_id', building_id_f%var,     &
+                                nxl, nxr, nys, nyn )
+          ELSE
+             building_id_f%from_file = .FALSE.
+          ENDIF
+!
+!--       Read building_type and required attributes.
+          IF ( check_existence( var_names, 'building_type' ) )  THEN
+             building_type_f%from_file = .TRUE.
+             CALL get_attribute( id_topo, char_fill,                           &
+                                 building_type_f%fill, .FALSE.,                &
+                                 'building_type' )
+
+             ALLOCATE ( building_type_f%var(nys:nyn,nxl:nxr) )
+
+             CALL get_variable( id_topo, 'building_type', building_type_f%var, &
+                                nxl, nxr, nys, nyn )
+
+          ELSE
+             building_type_f%from_file = .FALSE.
+          ENDIF
+!
+!--       Close topography input file
+          CALL close_input_file( id_topo )
 #else
-                CONTINUE
+          CONTINUE
 #endif
 !
-!--          ASCII input
-             ELSEIF ( TRIM( topography ) == 'read_from_file' )  THEN
+!--    ASCII input
+       ELSEIF ( TRIM( topography ) == 'read_from_file' )  THEN
+             
+          DO  ii = 0, io_blocks-1
+             IF ( ii == io_group )  THEN
 
                 OPEN( 90, FILE='TOPOGRAPHY_DATA'//TRIM( coupling_char ),       &
@@ -2021,10 +1957,10 @@
 
              ENDIF
-
-          ENDIF
 #if defined( __parallel )
-          CALL MPI_BARRIER( comm2d, ierr )
+             CALL MPI_BARRIER( comm2d, ierr )
 #endif
-       ENDDO
+          ENDDO
+
+       ENDIF
 !
 !--    End of CPU measurement
@@ -2117,12 +2053,11 @@
        CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names
 
+       LOGICAL      ::  dynamic_3d = .TRUE. !< flag indicating that 3D data is read from dynamic file
+       
        INTEGER(iwp) ::  i          !< running index along x-direction
-       INTEGER(iwp) ::  ii         !< running index for IO blocks
        INTEGER(iwp) ::  id_dynamic !< NetCDF id of dynamic input file
        INTEGER(iwp) ::  j          !< running index along y-direction
        INTEGER(iwp) ::  k          !< running index along z-direction
        INTEGER(iwp) ::  num_vars   !< number of variables in netcdf input file
-       INTEGER(iwp) ::  off_i      !< offset in x-direction used for reading the u-component
-       INTEGER(iwp) ::  off_j      !< offset in y-direction used for reading the v-component
 
        LOGICAL      ::  check_passed !< flag indicating if a check passed
